/*
** HDL4SE: VerilogۺϷƽ̨
** Copyright (C) 2021-2021, raoxianhong<raoxianhong@163.net>
** LCOM: ģ
** Copyright (C) 2021-2021, raoxianhong<raoxianhong@163.net>
** All rights reserved.
**
** Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are met:
**
** * Redistributions of source code must retain the above copyright notice,
**   this list of conditions and the following disclaimer.
** * Redistributions in binary form must reproduce the above copyright notice,
**   this list of conditions and the following disclaimer in the documentation
**   and/or other materials provided with the distribution.
** * The name of the author may be used to endorse or promote products
**   derived from this software without specific prior written permission.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
** AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
** IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
** ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
** LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
** THE POSSIBILITY OF SUCH DAMAGE.
*/

/*
* hdl4secell.c
  ޸ļ¼
	202105180851: rxh, initial version
*/
#include "stdlib.h" 
#include "stdio.h"
#include "object.h"
#define IMPLEMENT_GUID
#include "hdl4secell.h"
#undef IMPLEMENT_GUID

/*
  CLSIDʵһ·Ԫɳɹ·ԪparentһϷModule
  Ԫname뵽parent
*/
IHDL4SEUnit** hdl4seCreateUnit(IHDL4SEModule** parent, IIDTYPE clsid, char* instanceparam, char* name)
{
	PARAMITEM param[3];
	IHDL4SEUnit** result = NULL;
	param[0].name = PARAMID_HDL4SE_UNIT_INSTANCE_PARAMETERS;
	param[0].pvalue = instanceparam;
	param[1].name = PARAMID_HDL4SE_UNIT_NAME;
	param[1].pvalue = name;
	param[2].name = PARAMID_HDL4SE_UNIT_PARENT;
	param[2].pvalue = parent;
	objectCreateEx(clsid, param, 3, IID_HDL4SEUNIT, (const void**)&result);
	objectCall2(parent, AddUnit, result, name);
	return result;
}

/*
  ַнһ֣verilogָʽ Զʼķַ
  str: ַ
  value: ֻܱλݣֻ֧޷, ȣ
		 Ϊ32λΪʮ
		 valueṩܹҪĻ
		 ֵ˳value[0]:0--31λ value[1]--32..63λơ
  width: valueİλ
  pnextstr: ؽʣַ׵ַ
  ֵ
	>0  õֵλʱֵwidth򲢲valueдֵ
	򣺳:
	  -1; ûָȵ̫󣬻治
*/
enum TOKEN_STATE {
	TOKEN_INITIAL,
	TOKEN_NUM,
	TOKEN_BASE,
	TOKEN_BIN,
	TOKEN_OCT,
	TOKEN_DEC,
	TOKEN_HEX
};

static int actualwidth(unsigned int n)
{
	unsigned int c = 1;
	int ret = 1;
	if (c & 0x80000000)
		return 32;
	while (c < n) {
		c <<= 1;
		ret++;
	}
	return ret;
}

int str2verilognum(const char* str, HDL4SEUINT32* value, int width, const char** pnextstr)
{
	enum TOKEN_STATE state;
	const char* strt = str;
	int w = 0;
	int nw = 0;
	int aw = 0;
	int vlen = (width + 31) / 32;
	int b = 10;
	unsigned long long n;
	int valueindex = 0;
	state = TOKEN_INITIAL;
	*pnextstr = strt;
	while (*strt != 0) {
		int ch = *strt;
		switch (state) {
		case TOKEN_INITIAL: {
			if (ch == '\'') {
				state = TOKEN_BASE;
			}
			else if (ch >= '0' && ch <= '9') {
				n = ch - '0';
				state = TOKEN_NUM;
			}
		} break;
		case TOKEN_NUM: {
			if (ch >= '0' && ch <= '9') {
				n = n * 10 + ch - '0';
				if (n >= (1ll << 32)) {
					if (valueindex < vlen) {
						value[valueindex++] = n & 0xFFFFFFFF;
					}
					n >>= 32;
					aw += 32;
				}
			} else if (ch == '\'') {
				if (n > 1ll << 32)
					return -1;
				w = (int)n;
				if (w > width) {
					return w;
				}
				state = TOKEN_BASE;
			} else {
				nw = actualwidth((unsigned int)n);
				goto lastnum;
			}
		}break;
		case TOKEN_BASE: {
			if (ch == 'b' || ch == 'B') {
				b = 2;
				n = 0;
				nw = 0;
				aw = 0;
				state = TOKEN_BIN;
			} else if (ch == 'h' || ch == 'H') {
				b = 16;
				nw = 0;
				n = 0;
				aw = 0;
				state = TOKEN_HEX;
			} else if(ch == 'o' || ch == 'O') {
				b = 8;
				nw = 0;
				n = 0;
				aw = 0;
				state = TOKEN_OCT;
			} else if (ch == 'd' || ch == 'D') {
				b = 10;
				n = 0;
				aw = 0;
				state = TOKEN_DEC;
			} else if (ch == ' ' || ch == '\t' || ch == '\r' || ch == '\n') {

			} else {
				return -1;
			}
		}break;
		case TOKEN_BIN: {
			if (ch == '0' || ch == '1') {
				n <<= 1;
				nw++;
				n |= ch - '0';
				if (nw >= 32) {
					if (valueindex < vlen) {
						value[valueindex++] = n & 0xFFFFFFFF;
					}
					n >>= 32;
					aw += 32;
					nw -= 32;
				}
			} else if (ch == '_') {
			} else {
				goto lastnum;
			}
		}break;
		case TOKEN_OCT: {
			if (ch >= '0' && ch <= '7') {
				n <<= 3;
				nw += 3;
				n |= ch - '0';
				if (nw >= 32) {
					if (valueindex < vlen) {
						value[valueindex++] = n & 0xFFFFFFFF;
					}
					n >>= 32;
					aw += 32;
					nw -= 32;
				}
			}
			else if (ch == '_') {
			}
			else {
				goto lastnum;
			}
		}break;
		case TOKEN_DEC: {
			if (ch >= '0' && ch <= '9') {
				n = n * 10 + ch - '0';
				if (n >= (1ll << 32)) {
					if (valueindex < vlen) {
						value[valueindex++] = n & 0xFFFFFFFF;
					}
					n >>= 32;
					aw += 32;
				}
			} else {
				nw = actualwidth((unsigned int)n);
				goto lastnum;
			}
		}break;
		case TOKEN_HEX: {
			if ( (ch >= '0' && ch <= '9') || (ch >= 'a' && ch <= 'f') || (ch >= 'A' && ch <= 'F')) {
				n <<= 4;
				nw += 4;
				if (ch > '0' && ch <= '9')
					n |= ch - '0';
				else if (ch > 'a' && ch <= 'f')
					n |= ch - 'a' + 10;
				else if (ch > 'A' && ch <= 'F')
					n |= ch - 'A' + 10;
				if (nw >= 32) {
					if (valueindex < vlen) {
						value[valueindex++] = n & 0xFFFFFFFF;
					}
					n >>= 32;
					aw += 32;
					nw -= 32;
				}
			}
			else if (ch == '_') {
			}
			else {
				goto lastnum;
			}

		}break;
		}
		strt++;
	}
lastnum:
	*pnextstr = strt;
	if (valueindex < vlen) {
		value[valueindex++] = n & 0xFFFFFFFF;
	}
	aw += nw;
	return aw;
}

